//
//  GLViewController.m
//  FragmentShaderBase
//
//  Created by 神谷 栄治 on 12/05/12.
//  Copyright (c) 2012年 株式会社アイビス. All rights reserved.
//

#import "IBGLKit.h"
#import "GLViewController.h"

//プライベート
@interface GLViewController ()
// フラグメントシェーダーソース
@property(strong,nonatomic) NSString* fshSource;
@end


@implementation GLViewController
@synthesize glView = _glView;
@synthesize fshSource = _fshSource;

// 初期化
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

// ビューロード後イベント
- (void)viewDidLoad {
    [super viewDidLoad];
	self.glView.delegate = self;
	self.glView.contentScaleFactor = [UIScreen mainScreen].scale;	// Retina対応
}

// ビューアンロードイベント
- (void)viewDidUnload {
	[super viewDidUnload];
	[self.glView stopAnimation];
	self.glView = nil;
}

// ビュー表示前イベント
- (void)viewWillAppear:(BOOL)animated {
	[UIApplication sharedApplication].statusBarHidden = YES;//OSステータスバーOFF
	self.glView.shader.fragmentShader = self.fshSource;
	NSString* error = [self.glView.shader build];
	if(error){
		debug_NSLog(@"%@", error);
	}
}

// ビュー表示後イベント
- (void)viewDidAppear:(BOOL)animated {
	[super viewDidAppear:animated];
	[self.glView startAnimation];
	[self.navigationController setNavigationBarHidden:YES animated:YES];//ナビバーOFF
}

// ビュー非表示前イベント
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
	[self.glView stopAnimation];
	[UIApplication sharedApplication].statusBarHidden = NO;//OSステータスバーON
	[self.navigationController setNavigationBarHidden:NO animated:NO];//ナビバーON	
}

// ビュー非表示後イベント
- (void)viewDidDisappear:(BOOL)animated {
}

// 回転してよいか？
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	if([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone){//iPhoneのとき
		return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
	} else {//iPadのとき
		return YES;
	}
}

// GLViewでBackボタンが押された
- (void)onTappedBackButton {
	[self.navigationController popViewControllerAnimated:YES];
}

// フラグメントシェーダーのソースのセット
-(void)setFragmentShaderSource:(NSString*)fshSrc {
	self.fshSource = fshSrc;
}
@end
