//
//  MyGLView.mm
//  FragmentShaderBase
//
//  Created by 神谷 栄治 on 12/05/16.
//  Copyright (c) 2012年 株式会社アイビス. All rights reserved.
//

#import <math.h>
#import "MyGLView.h"
#import "IBGLImage.h"
#import "Color.h"
#import "Vector.h"

// プライベート
@interface MyGLView() {
	// 位置
	Vector positions[4];
	// テクスチャ座用
	Vector texCoords[4];
}
// 写真テクスチャ
@property(strong, nonatomic) IBGLImage* picture;
@end

@implementation MyGLView

@synthesize delegate = _delegate;
@synthesize shader = _shader;
@synthesize picture = _picture;

// 初期化
- (id)initWithCoder:(NSCoder*)coder {    
    self = [super initWithCoder:coder];
    if (self) {
		self.shader = [[MyShader alloc] init];
		self.picture = [[IBGLImage alloc] initWithUIImage:[UIImage imageNamed:@"Lenna"]];
    }
    return self;
}

// 描画
-(void)drawMain {
	// 色の計算
	double time = [NSDate timeIntervalSinceReferenceDate];
	float alpha = (float)((sin(M_PI * time / 2.0) + 1.0) / 2.0);
	Color color;
	color.setHue((float)fmod(time / 8.0, 1.0) * 360.f, 1.f);
	// 位置
	float w = fminf(self.width, self.height);
	positions[0] = Vector(0, 0);
	positions[1] = Vector(w, 0);
	positions[2] = Vector(0, w);
	positions[3] = Vector(w, w);
	// テクスチャ座標
	texCoords[0] = Vector(0,0);
	texCoords[1] = Vector(1,0);
	texCoords[2] = Vector(0,1);
	texCoords[3] = Vector(1,1);		
	[self.shader drawArraysMy:GL_TRIANGLE_STRIP positions:(float*)positions 
					  glImage:self.picture texCoords:(float*)texCoords count:4
						color:color alpha:alpha];
	[self drawFps];
}

// タッチダウンイベント
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
}

// タッチムーブイベント
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
}

// タッチアップイベント
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	[self.delegate onTappedBackButton];
}

// タッチキャンセルイベント
- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event {
}

@end
