//
//  Color.h
//  FragmentShaderBase
//
//  Created by 神谷 栄治 on 12/05/22.
//  Copyright (c) 2012年 株式会社アイビス. All rights reserved.
//

#ifndef FragmentShaderBase_Color_h
#define FragmentShaderBase_Color_h

//float型Color
//次の行でclassという予約語を知らないとエラーがでるときは、*.mmや*.cppからimportしてない
class Color { 
public:
	float r;
	float g;
	float b;
	float a;
public:
	// コンストラクタ（白）
	Color(){r=g=b=a=1.f;}
	// コンストラクタ(RGB指定）
	Color(float R, float G, float B){r=R;g=G;b=B;a=1.f;}
	// コンストラクタ(RGBA指定）
	Color(float R, float G, float B, float A){r=R;g=G;b=B;a=A;}
	// コンストラクタ(uint型 0xRRGGBBAA指定）
	Color(unsigned int rgba){
		a = (rgba & 0xff) / 255.f; rgba >>=8;
		b = (rgba & 0xff) / 255.f; rgba >>=8;
		g = (rgba & 0xff) / 255.f; rgba >>=8;
		r = (rgba & 0xff) / 255.f; rgba >>=8;
	}
	// コピーコンストラクタ
	Color(const Color& c){r=c.r;g=c.g;b=c.b;a=c.a;}
	// 設定(uchar型 RGBA指定）
	void setByInt(unsigned char R, unsigned char G, unsigned char B, unsigned char A){
		r=(float)R / 255.f;
		g=(float)G / 255.f;
		b=(float)B / 255.f;
		a=(float)A / 255.f;
	}
	// 色相から設定
	void setHue(float degree, float alpha);
};

#endif
