//
//  IBGL.mm
//  FragmentShaderBase
//
//  Created by 神谷 栄治 on 12/05/22.
//  Copyright (c) 2012年 株式会社アイビス. All rights reserved.
//

#import "IBGL.h"
#import "Matrix.h"

//プライベート
@interface IBGL() {
	//ビュー行列(4x4)
	float viewMatrix[16];
}
//初期化
-(id)init;

//ビューサイズ
@property(nonatomic) CGSize viewSize;
@end

//グローバル変数
static IBGL* g_instance = nil;


@implementation IBGL
@synthesize  viewSize = _viewSize;

//インスタンス取得（シングルトン）
+(IBGL*)sharedGL {
	if(g_instance == nil){//マルチスレッドでこのメソッドに入ってくることは考量していない
		g_instance = [[IBGL alloc] init];
	}
	return g_instance;
}

//初期化
-(id)init {
	self = [super init];
	if(self){
		
	}
	return self;
}

//ビューサイズ設定
-(void)setViewSize:(CGSize)size {
	_viewSize = size;
	Matrix m;
	m.addScale(Vector(2.f/size.width, -2.f/size.height));
	m.addTranslation(Vector(-1.f, 1.f));
	m.getMat4(viewMatrix);
}

//ビュー行列取得
-(const float*)viewMatrix {
	return viewMatrix;
}
@end
