//
//  IBGLKit.h
//  FragmentShaderBase
//
//  Created by 神谷 栄治 on 12/05/16.
//  Copyright (c) 2012年 株式会社アイビス. All rights reserved.
//

#ifndef FragmentShaderBase_IBGLKit_h
#define FragmentShaderBase_IBGLKit_h

#import <OpenGLES/ES2/gl.h>
#import <OpenGLES/ES2/glext.h>

#ifndef uint
#define uint unsigned int
#endif
#ifndef uchar
#define uchar unsigned char
#endif

#ifdef DEBUG //Debugビルド

#define debug_NSLog(format, ...) NSLog(format, ## __VA_ARGS__)
#define CHECK_GL_ERROR()	{ int err = glGetError(); \
	if (err != GL_NO_ERROR) { debug_NSLog(@"glGetError() = 0x%x\n", err); glGetError(); assert(false); } }

#else //Releaseビルド

#define debug_NSLog(format, ...)
#define CHECK_GL_ERROR()	

#endif

#import "IBGL.h"
#import "IBGLImage.h"
#import "IBGLShader.h"
#import "IBGLShaderPT.h"
#import "IBGLView.h"
#import "Color.h"
#import "Matrix.h"
#import "Vector.h"

#endif
